#!/usr/bin/env python
from xml.dom import *
from xml.dom import minidom
import string
from MultiDict import *

def getText(L):
	ret = ''
	for l in L.childNodes :
		if l.nodeType == l.TEXT_NODE:
			ret += l.data
	return ret

def mean(L):
	n = len(L)
	if n > 0:
		sum = 0.0
		for l in L:
			sum += l
		return sum / n
	else:
		return 0

def min(L):
	if len(L) > 0:
		m = L[0]
		for l in L:
			if l < m:
				m = l
		return m
	else:
		return 0


xmlFile = minidom.parse('results.xml')

# Get a list of the tests
testInfo = xmlFile.documentElement.getElementsByTagName ( 'test' )

inits    = [ 'default' , 'myinit' , 'centroid' ]
perts    = [ 'default' , 'melt' , 'split' , 'multistart' , 'far2k' ]
algos    = [ 'separationvns', 'default' ]


base = UnorderedMultiDict()
emptyList = []

# build the structure
for K in range(2,11):
	nbCluster = str(K)
	base[nbCluster] = UnorderedMultiDict()
	for a in algos:
		base[nbCluster][a] = UnorderedMultiDict()
		for p in perts:
			base[nbCluster][a][p] = UnorderedMultiDict()
			base[nbCluster][a][p]['default'] = UnorderedMultiDict()
			for i in inits:
				base[nbCluster][a][p]['default'][i] = UnorderedMultiDict()
				base[nbCluster][a][p]['default'][i]['default'] = []


# Go through each tests
for test in testInfo :
	init = 'default'
	vns  = 'default'
	perturbation = 'melt'
	nbCluster = '0'
	# get the structure
	for info in test.getElementsByTagName('input') :
		for n in info.getElementsByTagName('numberofclusters') :
			nbCluster = getText(n)
		for m in info.getElementsByTagName('methods') :
			for i in m.getElementsByTagName('initialisation') :
				init = getText(i)
			for i in m.getElementsByTagName('perturbation') :
				perturbation = getText(i)
			for i in m.getElementsByTagName('vns') :
				vns = getText(i)
	# store the error
	for result in test.getElementsByTagName('result') :
		for i in result.getElementsByTagName('error') :
			error = float(getText(i))

	base[nbCluster][vns][perturbation]['default'][init]['default'].append(error)

print "Show all stats:"
print "NbCluster = ", nbCluster
for a in algos:
	for p in perts:
		for i in inits:
			print "a=%s/p=%s/i=%s   |  nbElments=%i" % (a,p,i,len(base[nbCluster][a][p]['default'][i]['default']))
			print "Moyenne = ", mean(base[nbCluster][a][p]['default'][i]['default'])
			print "Meilleur= ", min(base[nbCluster][a][p]['default'][i]['default'])

